
/*

   polymorph routine declarations and defines, class declarations,
   and installation routine for PCOOPE2


	  Copyright (C) 1994, Brian Lee Price

	  released as PUBLIC DOMAIN 4/25/94


*/

/* prototype any special functions and declare necessary externals */


int    	MTaskIni(void);
object 	Schedule(object curTask);
object 	GetTask(void (*tm)());
int    	InstTask(void (*tm)(),int priority);

extern object taskSys[];

#define LOW_PRIORITY 3


/* declare all polymorph routines in all classes used */


DECLARE_POLY(pSet);
DECLARE_POLY(pAcc);
DECLARE_POLY(pToChar);
DECLARE_POLY(pToSInt);
DECLARE_POLY(pToUSInt);
DECLARE_POLY(pToLInt);
/* DECLARE_POLY(pToDbl); */
DECLARE_POLY(pToStd);
DECLARE_POLY(pToAlt);
DECLARE_POLY(pGetESz);
DECLARE_POLY(pReSz);
DECLARE_POLY(pGetSz);
DECLARE_POLY(pGetEl);
DECLARE_POLY(pPutEl);
DECLARE_POLY(pGetNel);
DECLARE_POLY(pGetPos);
DECLARE_POLY(pSetPos);
DECLARE_POLY(pStat);
DECLARE_POLY(pClrErr);
DECLARE_POLY(pPutc);
DECLARE_POLY(pGetc);
DECLARE_POLY(pUnGet);
DECLARE_POLY(pPuts);
DECLARE_POLY(pGets);
DECLARE_POLY(pPrint);
DECLARE_POLY(pScan);
DECLARE_POLY(pWrite);
DECLARE_POLY(pRead);
DECLARE_POLY(pAdd);
DECLARE_POLY(pPut);
DECLARE_POLY(pGet);
DECLARE_POLY(pRmv);
DECLARE_POLY(pNext);
DECLARE_POLY(pPrev);
DECLARE_POLY(pLook);
DECLARE_POLY(pUnLnk);
DECLARE_POLY(pIns);
DECLARE_POLY(pPause);
DECLARE_POLY(pReady);
DECLARE_POLY(pBlock);
DECLARE_POLY(pUsed);
DECLARE_POLY(pInUse);
DECLARE_POLY(pIsBlk);
DECLARE_POLY(pIsCur);
DECLARE_POLY(pSetP);
DECLARE_POLY(pGetP);
DECLARE_POLY(pWait);
DECLARE_POLY(pSignal);
DECLARE_POLY(pQuery);
DECLARE_POLY(pGetRd);
DECLARE_POLY(pGetWr);


/* define all polymorph routines used */

#define pSet     I_POLY(pSet)
#define pAcc     I_POLY(pAcc)
#define pToChar  I_POLY(pToChar)
#define pToSInt  I_POLY(pToSInt)
#define pToUSInt I_POLY(pToUSInt)
#define pToLInt  I_POLY(pToLInt)
/* #define pToDbl   I_POLY(pToDbl) */
#define pToStd   I_POLY(pToStd)
#define pToAlt   I_POLY(pToAlt)
#define pGetESz  I_POLY(pGetESz)
#define pReSz    I_POLY(pReSz)
#define pGetSz   I_POLY(pGetSz)
#define pGetEl   I_POLY(pGetEl)
#define pPutEl   I_POLY(pPutEl)
#define pGetNel  I_POLY(pGetNel)
#define pGetPos  I_POLY(pGetPos)
#define pSetPos  I_POLY(pSetPos)
#define pStat    I_POLY(pStat)
#define pClrErr  I_POLY(pClrErr)
#define pPutc    I_POLY(pPutc)
#define pGetc    I_POLY(pGetc)
#define pUnGet   I_POLY(pUnGet)
#define pPuts    I_POLY(pPuts)
#define pGets    I_POLY(pGets)
#define pPrint   I_POLY(pPrint)
#define pScan    I_POLY(pScan)
#define pWrite   I_POLY(pWrite)
#define pRead    I_POLY(pRead)
#define pAdd	 I_POLY(pAdd)
#define pPut	 I_POLY(pPut)
#define pGet	 I_POLY(pGet)
#define pRmv     I_POLY(pRmv)
#define pNext    I_POLY(pNext)
#define pPrev    I_POLY(pPrev)
#define pLook    I_POLY(pLook)
#define pUnLnk   I_POLY(pUnLnk)
#define pIns     I_POLY(pIns)
#define pPause   I_POLY(pPause)
#define pReady   I_POLY(pReady)
#define pBlock   I_POLY(pBlock)
#define pUsed    I_POLY(pUsed)
#define pInUse   I_POLY(pInUse)
#define pIsBlk   I_POLY(pIsBlk)
#define pIsCur   I_POLY(pIsCur)
#define pSetP    I_POLY(pSetP)
#define pGetP    I_POLY(pGetP)
#define pWait   I_POLY(pWait)
#define pSignal   I_POLY(pSignal)
#define pQuery   I_POLY(pQuery)
#define pGetRd   I_POLY(pGetRd)
#define pGetWr   I_POLY(pGetWr)


/* declare all child and ancestoral classes */

/* DECLARE_CLASS(Char);   */
/* DECLARE_CLASS(SInt);   */
/* DECLARE_CLASS(USInt);  */
DECLARE_CLASS(LInt);
/* DECLARE_CLASS(Dbl); */
/* DECLARE_CLASS(Ptr); */
DECLARE_CLASS(Dyn);
DECLARE_CLASS(Array);
DECLARE_CLASS(String);
DECLARE_CLASS(Stream);
DECLARE_CLASS(StdStrm);
/*  DECLARE_CLASS(File);  */
DECLARE_CLASS(DLLink);
DECLARE_CLASS(DLList);
DECLARE_CLASS(Thread);
DECLARE_CLASS(Sema4);
DECLARE_CLASS(Pipe);


/* install the classes */

void polyInit(void)
{
/* INSTALL_CLASS(Char);  */
/* INSTALL_CLASS(SInt);  */
/* INSTALL_CLASS(USInt); */
INSTALL_CLASS(LInt);
/* INSTALL_CLASS(Dbl); */
/* INSTALL_CLASS(Ptr); */
INSTALL_CLASS(Dyn);
INSTALL_CLASS(Array);
INSTALL_CLASS(String);
INSTALL_CLASS(Stream);
INSTALL_CLASS(StdStrm);
/* INSTALL_CLASS(File); */
INSTALL_CLASS(DLLink);
INSTALL_CLASS(DLList);
INSTALL_CLASS(Thread);
INSTALL_CLASS(Sema4);
INSTALL_CLASS(Pipe);

END_INIT;
}





